/***********************************************************************/
/*                                                                     */
/*  FILE        :interrupt_handlers.c                                  */
/*  DATE        :                                                      */
/*  DESCRIPTION :Interrupt Program                                     */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"

extern char Global_Buffer[1024];
int flag;
int head=0,tail=0;

int _read(int fd,void *buffer,unsigned int count)
{
  int i=0;
  char* buf=(char*)buffer;
  while(head==tail)                    // Mf[^҂
  {

  }
  while(1)
  {
    if(head==tail)                     // f[^M?
    {
      continue;  // wait receive data
    }
    if(i>=count)                       // woCgMς?
    {
      break;
    }
    buf[i]=Global_Buffer[head];        // Mf[^擾
    i++;
    head++;                            // Mf[^擪̍XV
    head%=1024;
    if(i>=2)                           // QoCgȏMς?
    {
      if( ( buf[i-2]=='\r' )           // CR?
      &&( buf[i-1]=='\n' ) )           // LF?
      {
        buf[i]=0;                      // NULLݒ
        break;                         // CRLF received rerurn
      }
    }
  }
  return i;
}

#pragma interrupt INT_ST2(vect=INTST2)
void INT_ST2 (void)
{
  flag = 1;                            // M
}
#pragma interrupt INT_SR1(vect=INTSR1)
void INT_SR1 (void)
{
  P14_bit.no6=!P14_bit.no6;            // P146]
  Global_Buffer[tail]=RXD1;            // Mf[^MOobt@Ɋi[
  tail++;                              // Mf[^i[̍XV
  tail%=1024;
}
