/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c                                                */
/*  DATE        :                                                      */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"

#define MOTOR_PORTMODE PM1
#define MOTOR_PORT P1

#define PWM1_ON() (MOTOR_PORT|=0x01)
#define PWM1_OFF() (MOTOR_PORT&=0xFE)
#define DIR1_ON() (MOTOR_PORT|=0x02)
#define DIR1_OFF() (MOTOR_PORT&=0xFD)
#define ENABLE1_OFF() (MOTOR_PORT|=0x04)
#define ENABLE1_ON() (MOTOR_PORT&=0xFB)

#define PWM2_ON() (MOTOR_PORT|=0x10)
#define PWM2_OFF() (MOTOR_PORT&=~0x10)
#define DIR2_ON() (MOTOR_PORT|=0x20)
#define DIR2_OFF() (MOTOR_PORT&=~0x20)
#define ENABLE2_OFF() (MOTOR_PORT|=0x40)
#define ENABLE2_ON() (MOTOR_PORT&=~0x40)

void main(void);

void Initialize_port(void)
{
  MOTOR_PORTMODE=0x00;
  MOTOR_PORT=0x00;
}

void delay_ms(int ms)
{
  volatile int i,j;
  for(i=0;i<ms;i++)
  {
    for(j=0;j<2963;j++)
    {

    }
  }
}
void main(void)
{
  Initialize_port();                   // |[g
  ENABLE1_ON();                        // [^P ON
  PWM1_ON();                           // PWM1 ON
  ENABLE2_ON();                        // [^Q ON
  PWM2_ON();                           // PWM2 ON

  while(1)
  {
    DIR1_ON();                         // [^P
    DIR2_ON();                         // [^Q
    delay_ms(1000);                    // 1s wait
    DIR1_OFF();                        // [^Pt
    DIR2_OFF();                        // [^Qt
    delay_ms(1000);                    // 1s wait
  }

}
