/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c                                                */
/*  DATE        :                                                      */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"

#define MOTOR_PORTMODE PM1
#define MOTOR_PORT P1

void main(void);

void port_init(void)
{
  MOTOR_PORTMODE=0x00;                 // [^|[go
  MOTOR_PORT=0x00;                     // [^|[gLow
}
unsigned char Left_1step_walk(char dir)
{
  static int leftStep=0;
  char step_left[]={0x09,0x01,0x03,0x02,0x06,0x04,0x0c,0x08};
  if(dir)                              // ?
  {
    leftStep++;                        // Abv
    leftStep%=8;                       // I[o[t[΍
  }
  else
  {
    if(leftStep==0)                    // ?
    {
      leftStep=7;                      // l
    }
    else
    {
      leftStep--;                      // _E
    }
  }
  return step_left[leftStep];          // steplԂ

}
unsigned char Right_1step_walk(char dir)
{
  static int rightStep=0;
  char step_right[]={0x90,0x10,0x30,0x20,0x60,0x40,0xc0,0x80};
  if(dir)                              // 
  {
    rightStep++;                       // Abv
    rightStep%=8;                      // I[o[t[΍
  }
  else
  {
    if(rightStep==0)                   // ?
    {
      rightStep=7;                     // l
    }
    else
    {
      rightStep--;                     // _E
    }
  }
  return step_right[rightStep];        // EsteplԂ
}
void delay_ms(int ms)
{
  volatile int i,j;
  for(i=0;i<ms;i++)
  {
    for(j=0;j<2963;j++)
    {

    }
  }
}
void main(void)
{
  unsigned char stepleft=0, stepright=0;

  port_init();                         // |[g
  while(1)
  {
    stepright = Right_1step_walk(1);   // E1step
    stepleft = Left_1step_walk(0);     // 1stept
    delay_ms(1);                       // 1ms wait
    MOTOR_PORT = stepleft|stepright;   // [^o
  }

}
