/***********************************************************************/
/*                                                                     */
/*  FILE        :interrupt_handlers.c                                  */
/*  DATE        :                                                      */
/*  DESCRIPTION :Interrupt Program                                     */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"

extern volatile unsigned char * gp_csi00_tx_address;  // csi00 send buffer address
extern volatile unsigned short  g_csi00_tx_count;     // csi00 send data count
extern unsigned char csi_send_end;

#pragma interrupt INT_csi00(vect=INTCSI00)
void INT_csi00 (void)
{
  unsigned char err_type;
  err_type = (unsigned char)(SSR00 & 0x0001 );  // G[擾
  SIR00 = err_type;                    // G[NA
  if( err_type != 1 )                  // I[o[G[Ȃ?
  {
    if(g_csi00_tx_count > 0)           // Mf[^?
    {
      SIO00 = *gp_csi00_tx_address;    // Mf[^ݒ
      gp_csi00_tx_address++;           // MAhXAbv
      g_csi00_tx_count--;              // MoCgJEg_E
    } else
    {
      csi_send_end = 1;                //@MZbg
    }
  }
}
