/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c                                                */
/*  DATE        :                                                      */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

struct _GPSINFO
{
  int hour;
  int min;
  float sec;
  char status;
  float latitude;
  char vertical_dir;
  float longitude;
  char horizonal_dir;
  float speed;
  float track_degree;
  int day;
  int month;
  int year;
  float magnetic_degree;
  char degree_dir;
  char mode;
  int checksum;
}GPSData;

char Global_Buffer[1024];
char Buffer[300];
extern int head,tail;
extern int flag;

void main(void);
extern int _read(int fd,void *buffer,unsigned int count);

extern void HardwareSetup(void);

int putchar(int c)
{
  TXD2 = (unsigned char)c;             // UART2Mݒ
  while(!flag)                         // ]ҋ@҂
  {
  }
  flag = 0;                            // ]ҋ@NA
  return c;  
}

void main(void)
{
  int i,j,Size;
  char Tokens[16][15];
  char* Now;

  HardwareSetup();                     // n[hEFAݒ
  SS0=0x000C;                          // VA02/03̒ʐMJn
  SS1=0x0003;                          // VA10/11̒ʐMJn
  PM14_bit.no6=0;                      // P146o
  while (1)
  {
    _read( 0,Buffer,sizeof(Buffer)-1); // M
    //printf("Original Message: %s\n",Buffer);

    if(strncmp(Buffer,"$GPRMC",strlen("$GPRMC")))  // "$GPRMC"ȊO?
    {
      continue;
    }
    j=0;
    Now=Buffer;
    Size=strlen(Buffer);               // obt@TCY擾
    for(i=0;i<Size;i++)
    {
      if(Buffer[i]==','||              // ؂蕶',','*','\r'?
         Buffer[i]=='*'||
         Buffer[i]=='\r')
      {
        Buffer[i]=0;                   // NULLɕύX
        strcpy(Tokens[j],Now);         // Rs[
        Now=&Buffer[i+1];              // ݂̃obt@XV
        j++;
      }
    }
    sscanf(Tokens[1],"%2d%2d%f",
      &GPSData.hour,&GPSData.min,&GPSData.sec);  // UTC
    GPSData.status=Tokens[2][0];       // M
    GPSData.latitude=atof(Tokens[3]);  // ܓx
    GPSData.vertical_dir=Tokens[4][0]; // ݈ʒu(k(N)/씼(S))
    GPSData.longitude=atof(Tokens[5]); // ox
    GPSData.horizonal_dir=Tokens[6][0];  // ݈ʒu(o(E)/o(W))
    GPSData.speed=atof(Tokens[7]);     // x(mbg)
    GPSData.track_degree=atof(Tokens[8]);  // is
    sscanf(Tokens[9],"%2d%2d%2d",
      &GPSData.day,&GPSData.month,&GPSData.year);  // t
    GPSData.magnetic_degree=atof(Tokens[10]);  // RpXpx
    GPSData.degree_dir=Tokens[11][0];  // RpXpx̌((E)/(W))
    GPSData.mode=Tokens[12][0];       // [h
    sscanf(Tokens[13],"%x",&GPSData.checksum);  // `FbNT
    puts("------------------\n");
    if( (GPSData.status=='V')||(GPSData.mode=='N') )  // f[^LłȂ?
    {
      printf("Initializing....\n");
    }
    else
    {
      printf("Time: %d:%d:%f\n-----------------"
        "\nLatitude: %d Deg %f ' : %c\nLongtitude: %d Deg %f ' : %c\n",
        GPSData.hour,GPSData.min,GPSData.sec,
        (int)GPSData.latitude/100,GPSData.latitude-(((int)GPSData.latitude/100)*100),
        GPSData.vertical_dir,
        (int)GPSData.longitude/100,GPSData.longitude-(((int)GPSData.longitude/100)*100),
        GPSData.horizonal_dir);
    }
    puts("------------------\n");
  }
}
